// generated from rosidl_typesupport_fastrtps_c/resource/idl__type_support_c.cpp.em
// with input from tuw_object_msgs:msg/ObjectWithCovariance.idl
// generated code does not contain a copyright notice
#include "tuw_object_msgs/msg/detail/object_with_covariance__rosidl_typesupport_fastrtps_c.h"


#include <cassert>
#include <limits>
#include <string>
#include "rosidl_typesupport_fastrtps_c/identifier.h"
#include "rosidl_typesupport_fastrtps_c/wstring_conversion.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "tuw_object_msgs/msg/rosidl_typesupport_fastrtps_c__visibility_control.h"
#include "tuw_object_msgs/msg/detail/object_with_covariance__struct.h"
#include "tuw_object_msgs/msg/detail/object_with_covariance__functions.h"
#include "fastcdr/Cdr.h"

#ifndef _WIN32
# pragma GCC diagnostic push
# pragma GCC diagnostic ignored "-Wunused-parameter"
# ifdef __clang__
#  pragma clang diagnostic ignored "-Wdeprecated-register"
#  pragma clang diagnostic ignored "-Wreturn-type-c-linkage"
# endif
#endif
#ifndef _WIN32
# pragma GCC diagnostic pop
#endif

// includes and forward declarations of message dependencies and their conversion functions

#if defined(__cplusplus)
extern "C"
{
#endif

#include "rosidl_runtime_c/primitives_sequence.h"  // correlation, covariance_pose, covariance_twist
#include "rosidl_runtime_c/primitives_sequence_functions.h"  // correlation, covariance_pose, covariance_twist
#include "tuw_object_msgs/msg/detail/object__functions.h"  // object

// forward declare type support functions
size_t get_serialized_size_tuw_object_msgs__msg__Object(
  const void * untyped_ros_message,
  size_t current_alignment);

size_t max_serialized_size_tuw_object_msgs__msg__Object(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);

const rosidl_message_type_support_t *
  ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, tuw_object_msgs, msg, Object)();


using _ObjectWithCovariance__ros_msg_type = tuw_object_msgs__msg__ObjectWithCovariance;

static bool _ObjectWithCovariance__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  const _ObjectWithCovariance__ros_msg_type * ros_message = static_cast<const _ObjectWithCovariance__ros_msg_type *>(untyped_ros_message);
  // Field name: object
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, tuw_object_msgs, msg, Object
      )()->data);
    if (!callbacks->cdr_serialize(
        &ros_message->object, cdr))
    {
      return false;
    }
  }

  // Field name: covariance_pose
  {
    size_t size = ros_message->covariance_pose.size;
    auto array_ptr = ros_message->covariance_pose.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  // Field name: covariance_twist
  {
    size_t size = ros_message->covariance_twist.size;
    auto array_ptr = ros_message->covariance_twist.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  // Field name: correlation
  {
    size_t size = ros_message->correlation.size;
    auto array_ptr = ros_message->correlation.data;
    cdr << static_cast<uint32_t>(size);
    cdr.serializeArray(array_ptr, size);
  }

  return true;
}

static bool _ObjectWithCovariance__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  if (!untyped_ros_message) {
    fprintf(stderr, "ros message handle is null\n");
    return false;
  }
  _ObjectWithCovariance__ros_msg_type * ros_message = static_cast<_ObjectWithCovariance__ros_msg_type *>(untyped_ros_message);
  // Field name: object
  {
    const message_type_support_callbacks_t * callbacks =
      static_cast<const message_type_support_callbacks_t *>(
      ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(
        rosidl_typesupport_fastrtps_c, tuw_object_msgs, msg, Object
      )()->data);
    if (!callbacks->cdr_deserialize(
        cdr, &ros_message->object))
    {
      return false;
    }
  }

  // Field name: covariance_pose
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->covariance_pose.data) {
      rosidl_runtime_c__double__Sequence__fini(&ros_message->covariance_pose);
    }
    if (!rosidl_runtime_c__double__Sequence__init(&ros_message->covariance_pose, size)) {
      fprintf(stderr, "failed to create array for field 'covariance_pose'");
      return false;
    }
    auto array_ptr = ros_message->covariance_pose.data;
    cdr.deserializeArray(array_ptr, size);
  }

  // Field name: covariance_twist
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->covariance_twist.data) {
      rosidl_runtime_c__double__Sequence__fini(&ros_message->covariance_twist);
    }
    if (!rosidl_runtime_c__double__Sequence__init(&ros_message->covariance_twist, size)) {
      fprintf(stderr, "failed to create array for field 'covariance_twist'");
      return false;
    }
    auto array_ptr = ros_message->covariance_twist.data;
    cdr.deserializeArray(array_ptr, size);
  }

  // Field name: correlation
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    if (ros_message->correlation.data) {
      rosidl_runtime_c__double__Sequence__fini(&ros_message->correlation);
    }
    if (!rosidl_runtime_c__double__Sequence__init(&ros_message->correlation, size)) {
      fprintf(stderr, "failed to create array for field 'correlation'");
      return false;
    }
    auto array_ptr = ros_message->correlation.data;
    cdr.deserializeArray(array_ptr, size);
  }

  return true;
}  // NOLINT(readability/fn_size)

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_tuw_object_msgs
size_t get_serialized_size_tuw_object_msgs__msg__ObjectWithCovariance(
  const void * untyped_ros_message,
  size_t current_alignment)
{
  const _ObjectWithCovariance__ros_msg_type * ros_message = static_cast<const _ObjectWithCovariance__ros_msg_type *>(untyped_ros_message);
  (void)ros_message;
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // field.name object

  current_alignment += get_serialized_size_tuw_object_msgs__msg__Object(
    &(ros_message->object), current_alignment);
  // field.name covariance_pose
  {
    size_t array_size = ros_message->covariance_pose.size;
    auto array_ptr = ros_message->covariance_pose.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name covariance_twist
  {
    size_t array_size = ros_message->covariance_twist.size;
    auto array_ptr = ros_message->covariance_twist.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // field.name correlation
  {
    size_t array_size = ros_message->correlation.size;
    auto array_ptr = ros_message->correlation.data;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);
    (void)array_ptr;
    size_t item_size = sizeof(array_ptr[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

static uint32_t _ObjectWithCovariance__get_serialized_size(const void * untyped_ros_message)
{
  return static_cast<uint32_t>(
    get_serialized_size_tuw_object_msgs__msg__ObjectWithCovariance(
      untyped_ros_message, 0));
}

ROSIDL_TYPESUPPORT_FASTRTPS_C_PUBLIC_tuw_object_msgs
size_t max_serialized_size_tuw_object_msgs__msg__ObjectWithCovariance(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  size_t last_member_size = 0;
  (void)last_member_size;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;

  // member: object
  {
    size_t array_size = 1;


    last_member_size = 0;
    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      size_t inner_size;
      inner_size =
        max_serialized_size_tuw_object_msgs__msg__Object(
        inner_full_bounded, inner_is_plain, current_alignment);
      last_member_size += inner_size;
      current_alignment += inner_size;
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }
  // member: covariance_pose
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }
  // member: covariance_twist
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }
  // member: correlation
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    last_member_size = array_size * sizeof(uint64_t);
    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  size_t ret_val = current_alignment - initial_alignment;
  if (is_plain) {
    // All members are plain, and type is not empty.
    // We still need to check that the in-memory alignment
    // is the same as the CDR mandated alignment.
    using DataType = tuw_object_msgs__msg__ObjectWithCovariance;
    is_plain =
      (
      offsetof(DataType, correlation) +
      last_member_size
      ) == ret_val;
  }

  return ret_val;
}

static size_t _ObjectWithCovariance__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_tuw_object_msgs__msg__ObjectWithCovariance(
    full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}


static message_type_support_callbacks_t __callbacks_ObjectWithCovariance = {
  "tuw_object_msgs::msg",
  "ObjectWithCovariance",
  _ObjectWithCovariance__cdr_serialize,
  _ObjectWithCovariance__cdr_deserialize,
  _ObjectWithCovariance__get_serialized_size,
  _ObjectWithCovariance__max_serialized_size
};

static rosidl_message_type_support_t _ObjectWithCovariance__type_support = {
  rosidl_typesupport_fastrtps_c__identifier,
  &__callbacks_ObjectWithCovariance,
  get_message_typesupport_handle_function,
};

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_c, tuw_object_msgs, msg, ObjectWithCovariance)() {
  return &_ObjectWithCovariance__type_support;
}

#if defined(__cplusplus)
}
#endif
